# -*- coding: utf-8 -*-
"""ProjectFMLbasic.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1icJA6QWGWqOp8l8PLIqGI99uUdBfbf5P

Unzipping th
"""

from google.colab import drive

# importing required modules 
from zipfile import ZipFile 

# specifying the zip file name 
file_name = "/content/drive/MyDrive/words/Copy of final_dataset_1800.zip"

# opening the zip file in READ mode 
with ZipFile(file_name, 'r') as zip: 
	# printing all the contents of the zip file 
	zip.printdir() 

	# extracting all the files 
	# print('Extracting all the files now...') 
	zip.extractall() 
	print('Done!')

"""Training of model
**STARTS_HERE**
"""

import csv
import cv2
import os
import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import matplotlib.image as im
from tensorflow.keras import datasets, layers, models
from keras.preprocessing.image import img_to_array, load_img
root_path = '/content/by_class/'
classes = os.listdir(root_path)
#print(len(classes))
x_train = []
y_train = []
y_train_dict = {}
index = 0
for each_class in classes[10:]:
  #print(type(each_class))
  if each_class not in [ '0' , '1' ,'2','3','4','5','6','7','8','9']:
    #...each_class is having 20 photos:
    curr_path = root_path + each_class
    curr_dir = os.listdir(curr_path)
    for image in curr_dir[:1000]:
        curr_image = curr_path + '/' + image
        image = cv2.imread(curr_image, cv2.IMREAD_GRAYSCALE)
        ret,new_img = cv2.threshold(image,200,255,cv2.THRESH_BINARY_INV)
        new_img = cv2.resize(new_img, (128, 128))
        x_train.append(new_img)
        y_train.append(index)
    y_train_dict[index] = each_class
    index += 1    
print('Done...')

x_train = np.array(x_train)
photos = x_train.shape[0]
x_train = x_train.reshape(photos ,128,128,1)
y_train = np.array(y_train)
#print(x_train[0].shape)
print('Done...')

from tensorflow.keras import datasets, layers, models
from keras.layers import Dense, Dropout, Flatten, Lambda, ELU, Activation, BatchNormalization
model = models.Sequential()
model.add(layers.Conv2D(32, (3, 3), activation='relu', input_shape=(128, 128, 1)))
model.add(layers.MaxPooling2D((2, 2)))
model.add(layers.Conv2D(64, (3, 3), activation='relu'))
model.add(layers.MaxPooling2D((2, 2)))
model.add(layers.Flatten())
model.add(layers.Dense(64, activation='relu'))
model.add(layers.Dense(64, activation='relu'))
model.add(layers.Dense(64, activation='relu'))
model.add(layers.Dense(62 , activation='softmax'))
#model.summary()
print('Done...')

from tensorflow.keras import losses
from tensorflow import keras
model.compile(
    optimizer=keras.optimizers.RMSprop(),  # Optimizer
    # Loss function to minimize
    loss=keras.losses.SparseCategoricalCrossentropy(),
    # List of metrics to monitor
    metrics=[keras.metrics.SparseCategoricalAccuracy()],
)

model.fit(x_train , y_train , epochs=10)

image = cv2.imread('/content/by_class/1/train_31_00003.png', cv2.IMREAD_GRAYSCALE)
ret,new_img = cv2.threshold(image,200,255,cv2.THRESH_BINARY_INV)
test_img = cv2.resize(new_img, (128,128))
plt.imshow(test_img , cmap='gray')
plt.show()
test = np.zeros((1,128,128,1))
test[0] += test_img.reshape(128,128,1)
pred = model.predict(test)
index = np.argmax(pred)
print(y_train_dict[index])

"""**Line segmentation**"""

image = cv2.imread('/content/drive/MyDrive/test5.jpeg', cv2.IMREAD_GRAYSCALE)
ret,new_img = cv2.threshold(image,200,255,cv2.THRESH_BINARY_INV)
new_img = cv2.copyMakeBorder(new_img, 10, 10, 10, 10, cv2.BORDER_CONSTANT , value = 0) 
horizontal_histogram  = np.zeros((new_img.shape[0] , 1))
print(horizontal_histogram.shape)
index = 0
while index in range(horizontal_histogram.shape[0]):
    horizontal_histogram[index]=np.sum(new_img[index][:])
    index += 1 
#print(horizontal_histogram)
index = 0
SC_list = []
SC = 0
even_odd = 0
#Defining threshold for line as 1pixel
for index in range(horizontal_histogram.shape[0]):
  if horizontal_histogram[index] > 0 and ( even_odd % 2 == 0 ):
      SC = np.mean(np.arange(SC,index-1))
      SC_list.append(SC)
      even_odd += 1
  elif horizontal_histogram[index] == 0 and (even_odd % 2 == 1):
    SC = index
    even_odd += 1
SC = np.mean(np.arange(SC,index-1))
SC_list.append(SC)
SC_list = np.ceil(SC_list)
#for each in SC_list:
#  new_img[int(each)][:] = 255



#new_img = cv2.resize(new_img, (64, 64))
plt.imshow(new_img , cmap='gray')

print(np.ceil(SC_list))

"""**Slicing of the image line-wise**"""

lines = []
counter = 0
limit = len(SC_list)
while counter < limit-1:
  iin = int(SC_list[counter])
  fin = int(SC_list[counter+1])
  if fin - iin > 75:
    lines.append(new_img[iin:fin+1][:])
  counter += 1
for index in range(len(lines)):
  plt.imshow(lines[index], cmap='gray')
  plt.show()

lines_new = []
for line in lines:
  vertical_projection = np.sum(line/255 , axis=0)
  i=0
  j=vertical_projection.shape[0]-1
  while i < vertical_projection.shape[0]-1:
    if (vertical_projection[i]>0):
      #print(i)
      break
    i += 1
  while j > 0:
    if (vertical_projection[j]>0):
      #print(j)
      break
    j -= 1
  
  plt.imshow(line[:,i-10:j+10] , cmap='gray')
  plt.show()
  lines_new.append(line[:,i-10:j+10])

lines = lines_new
for index in range(len(lines)):
  plt.imshow(lines[index], cmap='gray')
  plt.show()

"""**Character Preprocessing and padding**"""

#crop resize and border charachter
def char_preprocess(img):
    #find vertical projection
    vertical_projection = np.sum(img,axis=1)
    
    #find first and last non zeros projection
    left_index = 0
    right_index = 0
    for i in range(len(vertical_projection)):
        if (vertical_projection[i] != 0):
            left_index = i - 1
            break
    for j in range(len(vertical_projection)-1,0,-1):
        if (vertical_projection[j] != 0):
            right_index = j + 1
            break

    #crop image
    img_cropped = img[left_index: right_index,:]
    
    #resize image
    normalized_img = cv2.resize(img_cropped, (int(img_cropped.shape[1]*.3), int(img_cropped.shape[0]*.3)), interpolation = cv2.INTER_AREA)
    #imgplot = plt.imshow(img_cropped_resized , cmap='gray')
    #plt.show()
    #fill boder
    h = normalized_img.shape[0]
    w = normalized_img.shape[1]
    if h <= 128 and w <= 128:    
      thickness_h = int((128-h)/2)
      thickness_w = int((128-w)/2)
      #print(thickness_h,thickness_w,h,w)
      normalized_img = cv2.copyMakeBorder(normalized_img, thickness_h, thickness_h, thickness_w,thickness_w, cv2.BORDER_CONSTANT, value = [0,0])
    #imgplot = plt.imshow(normalized_img , cmap='gray')
    #plt.show()
    normalized_img = cv2.resize(normalized_img , (128,128) ,  interpolation = cv2.INTER_AREA)
    return(normalized_img)

"""**Segmenting Each word in the Line**"""

corrected_words = []
for line in lines:
  SC_list = []
  SC_list.append(0)
  #.....For each line processing....
  words = []
  vertical_projection = np.zeros((1,line.shape[1]))
  vertical_projection = np.sum(line/255,axis=0)
  #...code for SC/PSC
  cont_zeros = 0
  even_odd = 0
  SC = 0
  threshold = 100
  for counter in range(line.shape[1]):
    if vertical_projection[counter] == 0:
      cont_zeros += 1
      if cont_zeros > threshold:
        SC_list.append(counter-50)
        cont_zeros = 0
    else:
      cont_zeros = 0
  SC_list.append(counter)  
  SC_list= np.ceil(SC_list)
  plt.imshow(line , cmap='gray')
  plt.show()
  #print(SC_list)
  #.........................................
  counter = 0
  limit = len(SC_list)
  while counter < limit-1:
    iin = int(SC_list[counter])
    fin = int(SC_list[counter+1])
    words.append(line[:,iin:fin+1])
    counter += 1
  index = 0
  limit = len(words)
  while index < limit:
    if np.sum(words[index]) == 0:
      del words[index]
      limit -= 1
    index += 1
  # for index in range(len(words)):
  #   plt.imshow(words[index] , cmap='gray')
  #   plt.show()
  #..........................................
  #Character Segmentation
  for word in words:
    tempword = ''
    char_projection = np.sum(word/255 , axis=0)
    sp = 0
    sp_list = [0]
    limit = char_projection.shape[0]
    even_odd = 0
    for index in range(limit):
      if char_projection[index] > 0 and even_odd % 2 == 0:
        sp = np.mean(np.arange(sp, (index-1)))
        sp_list.append(sp)
        even_odd += 1
      elif char_projection[index] ==  0 and even_odd % 2 == 1:
        sp = index
        even_odd += 1
    sp = np.mean(np.arange(sp, (index-1)))
    sp_list.append(sp)
    sp_list = np.ceil(sp_list)
    #print(sp_list)
  #..........................................
    images = []
    counters = 0
    l = len(sp_list)
    while counters < l-1:
      iin = int(sp_list[counters])
      fin = int(sp_list[counters+1])
      images.append(word[:,iin:fin+1])
      counters += 1
    #.........
    index = 0
    limit = len(images)
    while index < limit:
      if np.sum(images[index]) == 0:
        del images[index]
        limit -= 1
      index += 1
    for image in images:
      #image = cv2.imread(image, cv2.IMREAD_GRAYSCALE)
      #plt.imshow(image,cmap='gray')
      #plt.show()
      #ret,new_img = cv2.threshold(image,200,255,cv2.THRESH_BINARY)
      #test_img = cv2.resize(new_img, (64,64))
      test_img = char_preprocess(image)
      #plt.imshow(test_img , cmap='gray')
      #plt.show()
      #plt.imshow(test_img , cmap='gray')
      #plt.show()
      test = np.zeros((1,128,128,1))
      test[0] += test_img.reshape(128,128,1)
      pred = model.predict(test)
      index = np.argmax(pred)
      print(y_train_dict[index] , end = '')
    print(' ' , end='')
  print('')
  #..........................................

from sklearn.metrics import confusion_matrix
index = 0
x_test = []
y_test = []
y_test_dict = {}
for each_class in classes[10:]:
  #print(type(each_class))
  if each_class not in [ '0' , '1' ,'2','3','4','5','6','7','8','9']:
    #...each_class is having 20 photos:
    curr_path = root_path + each_class
    curr_dir = os.listdir(curr_path)
    for image in curr_dir[1000:1010]:
        curr_image = curr_path + '/' + image
        image = cv2.imread(curr_image, cv2.IMREAD_GRAYSCALE)
        ret,new_img = cv2.threshold(image,200,255,cv2.THRESH_BINARY_INV)
        new_img = cv2.resize(new_img, (128, 128))
        x_test.append(new_img)
        y_test.append(index)
    y_test_dict[index] = each_class
    index += 1    
print('Done...')

y_predict_test = []
for each in x_test:
  each = cv2.resize(each , (128,128) ,  interpolation = cv2.INTER_AREA)
  test = np.zeros((1,128,128,1))
  test[0] += each.reshape(128,128,1)
  pred = model.predict(test)
  index = np.argmax(pred)
  y_predict_test.append(index)
print('out')
cm = confusion_matrix(y_true=y_test, y_pred=y_predict_test)
print(cm)

import seaborn as sns
pplot = sns.heatmap(cm)